﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Web.Profile;
using DA;


public class ProfileDemo : ProfileProvider
{

    public override SettingsPropertyValueCollection GetPropertyValues(SettingsContext context, SettingsPropertyCollection collection)
    {
        SettingsPropertyValueCollection settings = new SettingsPropertyValueCollection();
        if ((bool)context["IsAuthenticated"])
        {
            ProfileDemoDataContext db = new ProfileDemoDataContext();
            User user = (from u in db.Users where u.Username == (string)context["UserName"] select u).Single();
            if (user != null)
            {
                foreach (SettingsProperty sp in collection)
                {
                    SettingsPropertyValue settingsProperty = new SettingsPropertyValue(sp);
                    if (user.GetType().GetProperty(sp.Name) != null)
                        settingsProperty.PropertyValue = user.GetType().GetProperty(sp.Name).GetValue(user, null);
                    settings.Add(settingsProperty);
                }
            }
        }
        return settings;
    }

    public override void SetPropertyValues(SettingsContext context, SettingsPropertyValueCollection collection)
    {
        if ((bool)context["IsAuthenticated"])
        {
            ProfileDemoDataContext db = new ProfileDemoDataContext();
            User user = (from u in db.Users where u.Username == (string)context["UserName"] select u).Single();
            if (user != null)
            {
                foreach (SettingsPropertyValue spv in collection)
                {
                    if (user.GetType().GetProperty(spv.Name) != null)
                        user.GetType().GetProperty(spv.Name).SetValue(user, spv.PropertyValue, null);
                }
                db.SubmitChanges();
            }
        }
    }

    #region Nicht implementiert

    public override int DeleteInactiveProfiles(ProfileAuthenticationOption authenticationOption, DateTime userInactiveSinceDate)
    {
        throw new NotImplementedException();
    }

    public override int DeleteProfiles(string[] usernames)
    {
        throw new NotImplementedException();
    }

    public override int DeleteProfiles(ProfileInfoCollection profiles)
    {
        throw new NotImplementedException();
    }

    public override ProfileInfoCollection FindInactiveProfilesByUserName(ProfileAuthenticationOption authenticationOption, string usernameToMatch, DateTime userInactiveSinceDate, int pageIndex, int pageSize, out int totalRecords)
    {
        throw new NotImplementedException();
    }

    public override ProfileInfoCollection FindProfilesByUserName(ProfileAuthenticationOption authenticationOption, string usernameToMatch, int pageIndex, int pageSize, out int totalRecords)
    {
        throw new NotImplementedException();
    }

    public override ProfileInfoCollection GetAllInactiveProfiles(ProfileAuthenticationOption authenticationOption, DateTime userInactiveSinceDate, int pageIndex, int pageSize, out int totalRecords)
    {
        throw new NotImplementedException();
    }

    public override ProfileInfoCollection GetAllProfiles(ProfileAuthenticationOption authenticationOption, int pageIndex, int pageSize, out int totalRecords)
    {
        throw new NotImplementedException();
    }

    public override int GetNumberOfInactiveProfiles(ProfileAuthenticationOption authenticationOption, DateTime userInactiveSinceDate)
    {
        throw new NotImplementedException();
    }

    public override string ApplicationName
    {
        get
        {
            throw new NotImplementedException();
        }
        set
        {
            throw new NotImplementedException();
        }
    }

    #endregion

}
